Package org.optaplanner.core.impl.heuristic.selector.entity.decorator

## Class AbstractCachingEntitySelector<Solution_>

- java.lang.Object
- - org.optaplanner.core.impl.heuristic.selector.AbstractSelector<Solution_>
  - - org.optaplanner.core.impl.heuristic.selector.entity.AbstractEntitySelector<Solution_>
    - - org.optaplanner.core.impl.heuristic.selector.entity.decorator.AbstractCachingEntitySelector<Solution_>

- All Implemented Interfaces:
    `Iterable<Object>`, `EventListener`, `ListIterable<Object>`, `SelectionCacheLifecycleListener<Solution_>`, `EntitySelector<Solution_>`, `IterableSelector<Solution_,​Object>`, `ListIterableSelector<Solution_,​Object>`, `Selector<Solution_>`, `PhaseLifecycleListener<Solution_>`, `SolverLifecycleListener<Solution_>`
  Direct Known Subclasses:
    `CachingEntitySelector`, `ShufflingEntitySelector`, `SortingEntitySelector`

      public abstract class AbstractCachingEntitySelector<Solution_>
      extends AbstractEntitySelector<Solution_>
      implements SelectionCacheLifecycleListener<Solution_>

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected List<Object>` | `cachedEntityList` |
    `protected SelectionCacheType` | `cacheType` |
    `protected EntitySelector<Solution_>` | `childEntitySelector` |

    - ### Fields inherited from class org.optaplanner.core.impl.heuristic.selector.AbstractSelector

      `logger, phaseLifecycleSupport, workingRandom`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `AbstractCachingEntitySelector​(EntitySelector<Solution_> childEntitySelector, SelectionCacheType cacheType)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `constructCache​(SolverScope<Solution_> solverScope)` |
    `void` | `disposeCache​(SolverScope<Solution_> solverScope)` |
    `Iterator<Object>` | `endingIterator()` | If `Selector.isNeverEnding()` is true, then `Iterable.iterator()` will never end.
    `SelectionCacheType` | `getCacheType()` | Unless this selector itself caches, this returns `SelectionCacheType.JUST_IN_TIME`, even if a selector child caches.
    `EntitySelector<Solution_>` | `getChildEntitySelector()` |
    `EntityDescriptor<Solution_>` | `getEntityDescriptor()` |
    `long` | `getSize()` | A random JIT `Selector` with `Selector.isNeverEnding()` true should return a size as if it would be able to return each distinct element only once, because the size can be used in `SelectionProbabilityWeightFactory`.
    `boolean` | `isCountable()` | If false, then `Selector.isNeverEnding()` is true.

    - ### Methods inherited from class org.optaplanner.core.impl.heuristic.selector.AbstractSelector

      `phaseEnded, phaseStarted, solvingEnded, solvingStarted, stepEnded, stepStarted`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface java.lang.Iterable

      `forEach, iterator`

    - ### Methods inherited from interface org.optaplanner.core.impl.heuristic.selector.IterableSelector

      `spliterator`

    - ### Methods inherited from interface org.optaplanner.core.impl.heuristic.selector.common.iterator.ListIterable

      `listIterator, listIterator`

    - ### Methods inherited from interface org.optaplanner.core.impl.phase.event.PhaseLifecycleListener

      `phaseEnded, phaseStarted, stepEnded, stepStarted`

    - ### Methods inherited from interface org.optaplanner.core.impl.heuristic.selector.Selector

      `isNeverEnding`

    - ### Methods inherited from interface org.optaplanner.core.impl.solver.event.SolverLifecycleListener

      `solvingEnded, solvingStarted`

- - ### Field Detail

    - #### childEntitySelector

          protected final EntitySelector<Solution_> childEntitySelector

    - #### cacheType

          protected final SelectionCacheType cacheType

    - #### cachedEntityList

          protected List<Object> cachedEntityList

  - ### Constructor Detail

    - #### AbstractCachingEntitySelector

          public AbstractCachingEntitySelector​(EntitySelector<Solution_> childEntitySelector,
                                               SelectionCacheType cacheType)

  - ### Method Detail

    - #### getChildEntitySelector

          public EntitySelector<Solution_> getChildEntitySelector()

    - #### getCacheType

          public SelectionCacheType getCacheType()

      Description copied from interface: `Selector`
      Unless this selector itself caches, this returns `SelectionCacheType.JUST_IN_TIME`, even if a selector child caches.
      Specified by:
        `getCacheType` in interface `Selector<Solution_>`
      Overrides:
        `getCacheType` in class `AbstractSelector<Solution_>`
      Returns:
        never null

    - #### constructCache

          public void constructCache​(SolverScope<Solution_> solverScope)

      Specified by:
        `constructCache` in interface `SelectionCacheLifecycleListener<Solution_>`

    - #### disposeCache

          public void disposeCache​(SolverScope<Solution_> solverScope)

      Specified by:
        `disposeCache` in interface `SelectionCacheLifecycleListener<Solution_>`

    - #### getEntityDescriptor

          public EntityDescriptor<Solution_> getEntityDescriptor()

      Specified by:
        `getEntityDescriptor` in interface `EntitySelector<Solution_>`
      Returns:
        never null

    - #### isCountable

          public boolean isCountable()

      Description copied from interface: `Selector`
      If false, then `Selector.isNeverEnding()` is true.
      Specified by:
        `isCountable` in interface `Selector<Solution_>`
      Returns:
        true if all the `ValueRange`s are countable (for example a double value range between 1.2 and 1.4 is not countable)

    - #### getSize

          public long getSize()

      Description copied from interface: `IterableSelector`
      A random JIT `Selector` with `Selector.isNeverEnding()` true should return a size as if it would be able to return each distinct element only once, because the size can be used in `SelectionProbabilityWeightFactory`.
      Specified by:
        `getSize` in interface `IterableSelector<Solution_,​Object>`
      Returns:
        the approximate number of elements generated by this `Selector`, always `>= 0`

    - #### endingIterator

          public Iterator<Object> endingIterator()

      Description copied from interface: `EntitySelector`
      If `Selector.isNeverEnding()` is true, then `Iterable.iterator()` will never end. This returns an ending `Iterator`, that tries to match `Iterable.iterator()` as much as possible, but returns each distinct element only once and returns every element that might possibly be selected and therefore it might not respect the configuration of this `EntitySelector` entirely.
      Specified by:
        `endingIterator` in interface `EntitySelector<Solution_>`
      Returns:
        never null
      See Also:
        `Iterable.iterator()`